"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var klaw = require("klaw");
function walk(dir, filter) {
    if (filter === void 0) { filter = function () { return true; }; }
    return new Promise(function (resolve, reject) {
        var items = [];
        klaw(dir)
            .on("data", function (item) { return filter(item.path) ? items.push(item.path) : undefined; })
            .on("error", function (error) { return reject(error); })
            .on("end", function () { return resolve(items); });
    });
}
exports.walk = walk;
