"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var uuid = require("uuid/v4");
var promptly_1 = require("promptly");
exports.createTemplates = function (projectKey) { return [
    function () { return ({
        key: "appKey",
        defaultValue: projectKey
    }); },
    function () { return ({
        key: "appName",
        question: "What should the project be called?",
        defaultValue: projectKey
    }); },
    function () { return ({
        key: "author",
        question: "Who is creating this project?",
        defaultValue: projectKey
    }); },
    function () { return ({
        key: "timezone",
        question: "What cron timezone should be used?",
        defaultValue: "Etc./UTC"
    }); },
    function () { return ({
        key: "mysqlHost",
        question: "What is the mysql host?",
        defaultValue: "localhost"
    }); },
    function () { return ({
        key: "mysqlPort",
        question: "What is the mysql port?",
        defaultValue: "3306"
    }); },
    function (_a) {
        var appKey = _a.appKey;
        return ({
            key: "mysqlDatabase",
            question: "What is the mysql database name?",
            defaultValue: appKey.replace(/-/g, "_")
        });
    },
    function () { return ({
        key: "mysqlUsername",
        question: "What is the mysql username?",
        defaultValue: "kompost"
    }); },
    function () { return ({
        key: "mysqlPassword",
        question: "What is the mysql password?",
        defaultValue: uuid().toString()
    }); },
    function () { return ({
        key: "jwtKey",
        defaultValue: uuid().toString()
    }); }
]; };
function parseTemplates(projectKey) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _i, _a, builder, template, question, _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    result = {};
                    _i = 0, _a = exports.createTemplates(projectKey);
                    _d.label = 1;
                case 1:
                    if (!(_i < _a.length)) return [3 /*break*/, 6];
                    builder = _a[_i];
                    template = builder(result);
                    if (!template.question) return [3 /*break*/, 3];
                    question = template.question + "\n";
                    if (template.example) {
                        question += "example: '" + template.example + "'\n";
                    }
                    if (template.defaultValue) {
                        question += "default: '" + template.defaultValue + "'\n";
                    }
                    question += "\n>";
                    _b = result;
                    _c = template.key;
                    return [4 /*yield*/, promptly_1.prompt(question, { default: template.defaultValue })];
                case 2:
                    _b[_c] = _d.sent();
                    return [3 /*break*/, 4];
                case 3:
                    if (template.defaultValue) {
                        result[template.key] = template.defaultValue;
                    }
                    _d.label = 4;
                case 4:
                    console.log();
                    _d.label = 5;
                case 5:
                    _i++;
                    return [3 /*break*/, 1];
                case 6: return [2 /*return*/, result];
            }
        });
    });
}
exports.parseTemplates = parseTemplates;
