#!/usr/bin/env node
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var commander = require("commander");
var package_meta_loader_1 = require("./core/package-meta-loader");
var create_1 = require("./create");
var packageData = package_meta_loader_1.loadPackageMeta();
commander
    .command("create <dir>")
    .description("Create a new KomPOST project.")
    .action(function (dir) {
    create_1.default(dir).then(function () {
        console.log("Project created!");
        process.exit(0);
    }).catch(function (error) { return console.log("Error: " + error.message); });
});
if (process.argv.length < 3) {
    commander.help();
}
commander
    .version(packageData.version)
    .parse(process.argv);
